Index: issm/trunk/src/jl/usr/utils.jl
===================================================================
--- issm/trunk/src/jl/usr/utils.jl	(revision 26744)
+++ issm/trunk/src/jl/usr/utils.jl	(revision 26744)
@@ -0,0 +1,242 @@
+#utils
+function issmdir() #{{{
+	issmdir = ENV["ISSM_DIR"]
+
+	if isempty(issmdir)
+		error("Could not determine the location of ISSM")
+	else
+		return issmdir
+	end
+end#}}}
+function archread(filename::String,variablename::String) #{{{
+
+	#initialize variables
+	found = false
+
+	#open file
+	output = open(filename, "r") do f
+
+		while !eof(f)
+			reclen  = bswap(read(f, Int32))
+			rectype = bswap(read(f, Int32))
+			if rectype!=1
+				error("Expected variable of type string")
+			else
+				fieldname_length = bswap(read(f, Int32))
+				field_name = String(read(f, fieldname_length))
+			end
+			rec_length = bswap(read(f, Int32))
+			field_type = bswap(read(f, Int32))
+			if field_type==2
+				data = bswap(read(f, Float64))
+			elseif field_type==3
+				rows = bswap(read(f, Int32))
+				cols = bswap(read(f, Int32))
+				data = reinterpret(Float64, read(f, sizeof(Float64)*rows*cols))
+				data .= ntoh.(data)
+				data = reshape(data, (rows,cols))
+				data = collect(data)
+				if cols == 1
+					data = vec(data)
+				end
+			else
+				error("Error: Encountered invalid field type when reading data.")
+			end
+
+			if field_name == variablename
+				found = true
+				return data
+			end
+		end
+	end
+
+	return output
+end# }}}
+function InterpFromMeshToMesh2d(index_data::Array,x_data::Vector,y_data::Vector,data::Vector,xout::Vector,yout::Vector,default::Float64=NaN) #{{{
+
+	#Allocate output
+	nods_out = length(xout)
+	data_out = default*ones(nods_out)
+
+	#Interpolation type
+	data_length = size(data,1)
+	nods_data   = length(x_data)
+	nels_data   = size(index_data,1)
+	if(data_length==nods_data)
+		interpolation_type=1;
+	elseif (data_length==nels_data)
+		interpolation_type=2
+	else
+		error("length of vector data not supported yet. It should be of length (number of nodes) or (number of elements)!")
+	end
+	xmin = minimum(xout); xmax = maximum(xout)
+	ymin = minimum(yout); ymax = maximum(yout)
+
+	for i in 1:nels_data
+
+		#skip element if no overlap
+		if (minimum(x_data[index_data[i,:]]) > xmax) continue end
+		if (minimum(y_data[index_data[i,:]]) > ymax) continue end
+		if (maximum(x_data[index_data[i,:]]) < xmin) continue end
+		if (maximum(y_data[index_data[i,:]]) < ymin) continue end
+
+		#get area of the current element (Jacobian = 2 * area)*/
+		#area =x2 * y3 - y2*x3 + x1 * y2 - y1 * x2 + x3 * y1 - y3 * x1;
+		area = (x_data[index_data[i,2]]*y_data[index_data[i,3]]-y_data[index_data[i,2]]*x_data[index_data[i,3]] 
+				  +  x_data[index_data[i,1]]*y_data[index_data[i,2]]-y_data[index_data[i,1]]*x_data[index_data[i,2]] 
+				  +  x_data[index_data[i,3]]*y_data[index_data[i,1]]-y_data[index_data[i,3]]*x_data[index_data[i,1]])
+
+		for j in 1:nods_out
+			#Get first area coordinate = det(x-x3  x2-x3 ; y-y3   y2-y3)/area
+			area_1=((xout[j]-x_data[index_data[i,3]])*(y_data[index_data[i,2]]-y_data[index_data[i,3]])
+					 -  (yout[j]-y_data[index_data[i,3]])*(x_data[index_data[i,2]]-x_data[index_data[i,3]]))/area
+			#Get second area coordinate =det(x1-x3  x-x3 ; y1-y3   y-y3)/area
+			area_2=((x_data[index_data[i,1]]-x_data[index_data[i,3]])*(yout[j]-y_data[index_data[i,3]])
+					  - (y_data[index_data[i,1]]-y_data[index_data[i,3]])*(xout[j]-x_data[index_data[i,3]]))/area
+			#Get third area coordinate = 1-area1-area2
+			area_3=1-area_1-area_2
+
+			if (area_1>=0 && area_2>=0 && area_3>=0)
+				if (interpolation_type==1)
+					#nodal interpolation
+					data_out[j]=area_1*data[index_data[i,1]]+area_2*data[index_data[i,2]]+area_3*data[index_data[i,3]];
+				else
+					#element interpolation
+					data_out[j]=data[i];
+				end
+			end
+		end
+	end
+	return data_out
+
+	#OLD STUFF!!! not working...
+	
+	#prepare input arrays
+	nods = Cint(length(x))
+	nels = Cint(size(index,1))
+	nods_interp = Cint(length(xout))
+	Cindex=Array{Cint,1}(undef,length(index))
+	for i in 1:size(index,1)
+		for j in 1:3
+			Cindex[(i-1)*3+j] = Int32(index[i,j])
+		end
+	end
+	Cx    = Array{Cdouble,1}(undef,nods)
+	Cy    = Array{Cdouble,1}(undef,nods)
+	Cdata = Array{Cdouble,1}(undef,nods)
+	for i in 1:nods
+		Cx[i]    = x[i]
+		Cy[i]    = y[i]
+		Cdata[i] = data[i]
+	end
+	Cxout = Array{Cdouble,1}(undef,nods_interp)
+	Cyout = Array{Cdouble,1}(undef,nods_interp)
+	for i in 1:nods_interp
+		Cxout[i] = xout[i]
+		Cyout[i] = yout[i]
+	end
+
+	Cdataout = Vector{Float64}(undef,nods_interp)
+
+	#This is not working....
+	rc=ccall( (:InterpFromMeshToMesh2dx,"libISSMCore"),
+				Cint, (Ptr{Ptr{Cdouble}},Ptr{Cint}, Ptr{Cdouble}, Ptr{Cdouble}, Cint, Cint, Ptr{Cdouble}, Cint, Cint, Ptr{Cdouble}, Ptr{Cdouble}, Cint),
+				Ref(Ref(Cdataout)), Ref(Cindex), Ref(Cx), Ref(Cy), nods, nels,
+				Ref(Cdata), nods, 1, Ref(Cxout), Ref(Cyout), nods_interp)
+
+	#Process output
+	dataout = Vector{Float64}(undef,nods_interp)
+	for i in 1:nods_interp
+		dataout[i] = Cdataout[i]
+	end
+
+	return dataout
+end #}}}
+function InterpFromMeshToMesh2d2(index_data::Array,x_data::Vector,y_data::Vector,data::Vector,xout::Vector,yout::Vector) #{{{
+
+	#prepare input arrays
+	nods = Cint(length(x_data))
+	nels = Cint(size(index_data,1))
+	nods_interp = Cint(length(xout))
+	Cindex=Array{Cint,1}(undef,length(index_data))
+	for i in 1:size(index_data,1)
+		for j in 1:3
+			Cindex[(i-1)*3+j] = Int32(index_data[i,j])
+		end
+	end
+	Cx    = Array{Cdouble,1}(undef,nods)
+	Cy    = Array{Cdouble,1}(undef,nods)
+	Cdata = Array{Cdouble,1}(undef,nods)
+	for i in 1:nods
+		Cx[i]    = x_data[i]
+		Cy[i]    = y_data[i]
+		Cdata[i] = data[i]
+	end
+	Cxout    = Array{Cdouble,1}(undef,nods_interp)
+	Cyout    = Array{Cdouble,1}(undef,nods_interp)
+	Cdataout = Array{Cdouble,1}(undef,nods_interp)
+	for i in 1:nods_interp
+		Cxout[i] = xout[i]
+		Cyout[i] = yout[i]
+	end
+
+	#This is not working....
+	#rc=ccall( (:InterpFromMeshToMesh2dx,"../bamg/libBamg.so"),
+	#			Cint, (Ptr{Cdouble},Ptr{Cint}, Ptr{Cdouble}, Ptr{Cdouble}, Cint, Cint, Ptr{Cdouble}, Cint, Cint, Ptr{Cdouble}, Ptr{Cdouble}, Cint),
+	#			Ref(Cdataout), Ref(Cindex), Ref(Cx), Ref(Cy), nods, nels,
+	#			Ref(Cdata), nods, 1, Ref(Cxout), Ref(Cyout), nods_interp)
+	#rc=ccall( (:InterpFromMeshToMesh2dx,"../bamg/libBamg.so"),
+	#			Cint, (Ptr{Cint}, Ptr{Cdouble}, Ptr{Cdouble}, Cint, Cint),
+	#			Ref(Cindex), Ref(Cx), Ref(Cy), nods, nels)
+	#
+	#
+	dataout = Vector{Float64}(undef,nods_interp)
+	rc=ccall( (:InterpFromMeshToMesh2dx3,"/Users/mmorligh/Desktop/issmuci/trunk-jpl/src/jl/bamg/libBamg.dylib"),
+				Cint, (Ptr{Cdouble}, Cint),
+				dataout, nods_interp)
+
+	#Process output
+	for i in 1:nods_interp
+		dataout[i] = Cdataout[i]
+	end
+
+	return dataout
+end #}}}
+function solve(md::model,solution::String) #{{{
+
+	if solution=="sb" || solution=="Stressbalance"
+		solutionstring = "StressbalanceSolution"
+	elseif solution=="tr" || solution=="Transient"
+			solutionstring = "TransientSolution"
+	else
+		error("solutionstring "*solution*" not supported!");
+	end
+
+	IssmCore(md, solutionstring)
+
+	return md
+end #}}}
+function IssmStructDisp(io::IO, modelfield::Any) # {{{
+	println(io,typeof(modelfield),":")
+	for name in fieldnames(typeof(modelfield))
+		a=getfield(modelfield,name)
+		#print(io,"   $(name) = ")
+		@printf "%19s: " name
+		if isa(a,String)
+			println(io, a)
+		elseif length(a)>1
+			if !isempty(a)
+				println(io, typeof(a), " of size ", size(a))
+			else
+				println(io,"empty")
+			end
+		else
+			println(io, a)
+		end
+	end
+end #}}}
+function meshgrid(x::Vector, y::Vector)
+    X = [i for i in x, j in 1:length(y)]
+    Y = [j for i in 1:length(x), j in y]
+    return X, Y
+end
Index: issm/trunk/src/m/archive/arch.py
===================================================================
--- issm/trunk/src/m/archive/arch.py	(revision 25994)
+++ issm/trunk/src/m/archive/arch.py	(revision 26744)
@@ -6,8 +6,8 @@
 
 def archwrite(filename, *args):  # {{{
-    """
-    ARCHWRITE - Write data to a field, given the file name, field name, and data.
-        Usage:
-            archwrite('archive101.arch', 'variable_name', data)
+    """ARCHWRITE - Write data to a field, given the file name, field name, and data.
+
+    Usage:
+        archwrite('archive101.arch', 'variable_name', data)
     """
 
@@ -45,9 +45,9 @@
 
 def archread(filename, fieldname):  # {{{
-    """
-    ARCHREAD - Given an arch file name, and a field name, find and return the data
-                    associated with that field name.
-        Usage:
-            archread('archive101.arch', 'field_var_1')
+    """ARCHREAD - Given an arch file name, and a field name, find and return 
+    the data associated with that field name.
+
+    Usage:
+        archread('archive101.arch', 'field_var_1')
     """
     try:
@@ -76,9 +76,8 @@
 
 def archdisp(filename):  # {{{
-    """
-    ARCHDISP - Given an arch filename, display the contents of that file
-
-        Usage:
-            archdisp('archive101.arch')
+    """ARCHDISP - Given an arch filename, display the contents of that file
+
+    Usage:
+        archdisp('archive101.arch')
     """
     try:
@@ -97,5 +96,5 @@
         print(('\t\tSize:\t\t{0}'.format(result['size'])))
         print(('\t\tDatatype:\t{0}'.format(result['data_type'])))
-    # go to next result
+        # go to next result
         result = read_field(fid)
     # close file
@@ -106,6 +105,5 @@
 # Helper functions
 def write_field_name(fid, data):  # {{{
-    """
-    Routine to write field name (variable name) to an archive file.
+    """Routine to write field name (variable name) to an archive file.
     """
     # write the length of the record
@@ -125,6 +123,5 @@
 
 def write_scalar(fid, data):  # {{{
-    """
-    Procedure to write a double to an arch file pointed to by fid
+    """Procedure to write a double to an arch file pointed to by fid
     """
     # write length of record
@@ -141,6 +138,5 @@
 
 def write_vector(fid, data):  # {{{
-    """
-    Procedure to write a np.array to an arch file
+    """Procedure to write a np.array to an arch file
     """
     # Make sure our vector is the correct shape.
@@ -161,5 +157,5 @@
     reclen = 4 + 4 + 4 + 8 * sz[0] * sz[1]
     # make sure we can fit data into file
-    if reclen > 2**31:
+    if reclen > pow(2, 31):
         raise ValueError("archwrite error : can not write vector to binary file because it is too large")
     fid.write(struct.pack('>i', reclen))
@@ -176,16 +172,17 @@
 
 def read_field(fid):  # {{{
-    """
-    Procedure to read a field and return a results list with the following attributes:
-    result['field_name']     -> the name of the variable that was just read
-    result['size']             -> size (dimensions) of the variable just read
-    result['data_type']     -> the type of data that was just read
-    result['data']             -> the actual data
+    """Procedure to read a field and return a results list with the following 
+    attributes:
+
+        result['field_name']    -> the name of the variable that was just read
+        result['size']          -> size (dimensions) of the variable just read
+        result['data_type']     -> the type of data that was just read
+        result['data']          -> the actual data
     """
 
     try:
         # first, read the string
-        #first read the size and continue reading
-        struct.unpack('>i', fid.read(struct.calcsize('>i')))[0]  #name length
+        # first read the size and continue reading
+        struct.unpack('>i', fid.read(struct.calcsize('>i')))[0]  # name length
         check_name = struct.unpack('>i', fid.read(struct.calcsize('>i')))[0]
         if check_name != 1:
@@ -194,6 +191,6 @@
         fieldname = struct.unpack('>{}s'.format(namelen), fid.read(namelen))[0]
         # then, read the data
-        #first read the size and continue reading
-        struct.unpack('>i', fid.read(struct.calcsize('>i')))[0]  #data length
+        # first read the size and continue reading
+        struct.unpack('>i', fid.read(struct.calcsize('>i')))[0]  # data length
         data_type = struct.unpack('>i', fid.read(struct.calcsize('>i')))[0]
 
@@ -235,22 +232,19 @@
 
 
-def format_archive_code(format):  # {{{
-    """
-    Given a variable, determine it's type and return
-    an integer value:
-
-    1 : string
-    2 : double (scalar)
-    3 : vector or matrix (of type double)
-
-    """
-    if isinstance(format, str):
+def format_archive_code(var):  # {{{
+    """Given a variable, determine it's type and return an integer value:
+
+        1 : string
+        2 : double (scalar)
+        3 : vector or matrix (of type double)
+    """
+    if isinstance(var, str):
         code = 1
-    elif format.shape[0] == 1 and format.shape[1] == 1:
+    elif var.shape[0] == 1 and var.shape[1] == 1:
         code = 2
-    elif isinstance(format, (list, tuple, np.ndarray)):
+    elif isinstance(var, (list, tuple, np.ndarray)):
         code = 3
     else:
-        raise TypeError("archwrite error: data type '%s' is not valid." % type(format))
+        raise TypeError('archwrite error: data type {} is not valid.'.format(type(var)))
     return code
     # }}}
Index: issm/trunk/src/m/array/arrayoperations.js
===================================================================
--- issm/trunk/src/m/array/arrayoperations.js	(revision 25994)
+++ issm/trunk/src/m/array/arrayoperations.js	(revision 26744)
@@ -54,5 +54,5 @@
 	for (var a = 0; a < arguments.length; a++) {
         arg = arguments[a];
-        if (arg instanceof Array) {
+        if (arg instanceof Array || arg instanceof Float64Array) {
             size = arg.length;
             array = arg;
@@ -64,7 +64,7 @@
 	for (var a = 0; a < arguments.length; a++) {
         arg = arguments[a];
-        if (arg instanceof Array && arg.length != size) {
+        if ((arg instanceof Array || arg instanceof Float64Array) && arg.length != size) {
             throw Error("ArrayAdd error message: arrays provided as arguments are not of the same length!");
-        } else if (!(arg instanceof Array) && typeof arg != 'number') {
+        } else if (!(arg instanceof Array || arg instanceof Float64Array) && typeof arg != 'number') {
             throw Error("ArrayAdd error message: arguments provided are not of the type Array or Number!");
         }
@@ -75,9 +75,9 @@
 		if (a != initial) {
 			arg = arguments[a];
-			if (arg instanceof Array) {
+			if (arg instanceof Array || arg instanceof Float64Array) {
 				for(var i = 0; i < result.length; i++){
 					result[i] += arg[i];
 				}
-			} else if (typeof arg != 'number') {
+			} else if (typeof arg === 'number') {
 				for(var i = 0; i < result.length; i++){
 					result[i] += arg;
@@ -94,5 +94,5 @@
 	for (var a = 0; a < arguments.length; a++) {
         arg = arguments[a];
-        if (arg instanceof Array) {
+        if (arg instanceof Array || arg instanceof Float64Array) {
             size = arg.length;
             array = arg;
@@ -104,7 +104,7 @@
 	for (var a = 0; a < arguments.length; a++) {
         arg = arguments[a];
-        if (arg instanceof Array && arg.length != size) {
+        if ((arg instanceof Array || arg instanceof Float64Array) && arg.length != size) {
             throw Error("ArrayAdd error message: arrays provided as arguments are not of the same length!");
-        } else if (!(arg instanceof Array) && typeof arg != 'number') {
+        } else if (!(arg instanceof Array || arg instanceof Float64Array) && typeof arg != 'number') {
             throw Error("ArrayAdd error message: arguments provided are not of the type Array or Number!");
         }
@@ -115,11 +115,57 @@
 		if (a !== initial) {
 			arg = arguments[a];
-			if (arg instanceof Array) {
+			if (arg instanceof Array || arg instanceof Float64Array) {
 				for(var i = 0; i < result.length; i++){
 					result[i] -= arg[i];
 				}
-			} else if (typeof arg != 'number') {
+			} else if (typeof arg === 'number') {
 				for(var i = 0; i < result.length; i++){
 					result[i] -= arg;
+				}
+			}
+        }
+	}
+	return result;
+} //}}}
+function ArraySubtract2D(){ //{{{
+    //Takes in any number of scalars or arrays, and calculates the subtraction. Scalars are treated as similar length arrays of the scalar.
+    //Determine reference array and size
+    var size, array, arg, initial;
+	for (var a = 0; a < arguments.length; a++) {
+        arg = arguments[a];
+        if (arg instanceof Array || arg instanceof Float64Array) {
+            size = arg.length;
+            array = arg;
+			initial = a;
+            break;
+        }
+    }
+	//check internal consistency of arrays provided!: 
+	for (var a = 0; a < arguments.length; a++) {
+        arg = arguments[a];
+        if ((arg instanceof Array || arg instanceof Float64Array) && arg.length != size) {
+            throw Error("ArrayAdd error message: arrays provided as arguments are not of the same length!");
+        } else if (!(arg instanceof Array || arg instanceof Float64Array) && typeof arg != 'number') {
+            throw Error("ArrayAdd error message: arguments provided are not of the type Array or Number!");
+        }
+	}
+	//calculate the result, using the first argument to initialize:
+	var result = [];
+	for (var a = 0; a < arguments.length; a++) {
+		if (a !== initial) {
+			arg = arguments[a];
+			if (arg instanceof Array || arg instanceof Float64Array) {
+				for(var i = 0; i < array.length; i++){
+					result[i] = [];
+					for(var j = 0; j < array[i].length; j++){
+					    result[i][j] = array[i][j] - arg[i][j];
+					}
+				}
+			} else if (typeof arg === 'number') {
+				for(var i = 0; i < array.length; i++){
+					result[i] = [];
+					for(var j = 0; j < array[i].length; j++){
+					    result[i][j] = array[i][j] - arg;
+					}
 				}
 			}
@@ -134,5 +180,5 @@
 	for (var a = 0; a < arguments.length; a++) {
         arg = arguments[a];
-        if (arg instanceof Array) {
+        if (arg instanceof Array || arg instanceof Float64Array) {
             size = arg.length;
             array = arg;
@@ -144,7 +190,7 @@
 	for (var a = 0; a < arguments.length; a++) {
         arg = arguments[a];
-        if (arg instanceof Array && arg.length != size) {
+        if ((arg instanceof Array || arg instanceof Float64Array) && arg.length != size) {
             throw Error("ArrayAdd error message: arrays provided as arguments are not of the same length!");
-        } else if (!(arg instanceof Array) && typeof arg != 'number') {
+        } else if (!(arg instanceof Array || arg instanceof Float64Array) && typeof arg != 'number') {
             throw Error("ArrayAdd error message: arguments provided are not of the type Array or Number!");
         }
@@ -155,9 +201,9 @@
 		if (a !== initial) {
 			arg = arguments[a];
-			if (arg instanceof Array) {
+			if (arg instanceof Array || arg instanceof Float64Array) {
 				for(var i = 0; i < result.length; i++){
 					result[i] *= arg[i];
 				}
-			} else if (typeof arg != 'number') {
+			} else if (typeof arg === 'number') {
 				for(var i = 0; i < result.length; i++){
 					result[i] *= arg;
@@ -174,5 +220,5 @@
 	for (var a = 0; a < arguments.length; a++) {
         arg = arguments[a];
-        if (arg instanceof Array) {
+        if (arg instanceof Array || arg instanceof Float64Array) {
             size = arg.length;
             array = arg;
@@ -184,7 +230,7 @@
 	for (var a = 0; a < arguments.length; a++) {
         arg = arguments[a];
-        if (arg instanceof Array && arg.length != size) {
+        if ((arg instanceof Array || arg instanceof Float64Array) && arg.length != size) {
             throw Error("ArrayAdd error message: arrays provided as arguments are not of the same length!");
-        } else if (!(arg instanceof Array) && typeof arg != 'number') {
+        } else if (!(arg instanceof Array || arg instanceof Float64Array) && typeof arg != 'number') {
             throw Error("ArrayAdd error message: arguments provided are not of the type Array or Number!");
         }
@@ -195,9 +241,9 @@
 		if (a !== initial) {
 			arg = arguments[a];
-			if (arg instanceof Array) {
+			if (arg instanceof Array || arg instanceof Float64Array) {
 				for(var i = 0; i < result.length; i++){
 					result[i] /= arg[i];
 				}
-			} else if (typeof arg != 'number') {
+			} else if (typeof arg === 'number') {
 				for(var i = 0; i < result.length; i++){
 					result[i] /= arg;
@@ -282,27 +328,4 @@
 
 } //}}}
-function ArrayOr(){ //{{{
-    if (arguments.length<2)throw Error("ArrayOr error message: sum has to be for at least two arrays!");
-
-	//check internal consistency of arrays provided!: 
-	var firstarray=arguments[0];
-	var firstsize=firstarray.length;
-	
-	for(var a=1;a<arguments.length;a++){
-		var array=arguments[a];
-		if(array.length!=firstsize)throw Error("ArrayOr error message: arrays provided as arguments are not of the same length!");
-	}
-
-	//do the or:
-	var or=NewArrayFill(firstsize,0);
-	for(var a=0;a<arguments.length;a++){
-		var array=arguments[a];
-		for(var i=0;i<array.length;i++){
-			or[i] = or[i] | array[i];
-		}
-	}
-	return or;
-
-} //}}}
 function ArrayConcat(a, b) { //{{{
 	// Make sure that both typed arrays are of the same type
@@ -322,22 +345,22 @@
 } //}}}
 function ArrayCol(matrix, cols) { //{{{
-    var column = [];
-    if (cols instanceof Array) {
+    var columns = [];
+    if (cols instanceof Array || cols instanceof Float64Array) {
         for (var i = 0; i < matrix.length; i++){
-            var row = [];
-            for (var j = cols[0]; j <= cols[1]; j++){
-                row.push(matrix[i][j]);
+            var col = [];
+            for (var j = 0; j < cols.length; j++){
+                col.push(matrix[i][cols[j]]);
             }
-            column.push(row); 
+            columns.push(col); 
         }
 
     } else if (typeof cols == 'number') {
         for (var i = 0; i < matrix.length; i++){
-            column.push(matrix[i][cols]);
+            columns.push(matrix[i][cols]);
         }
     } else {
         throw new Error("ArrayCol error: cols must be a single integer or an array with 2 integers!");
     }
-   return column;
+   return columns;
 } //}}}
 function ListToMatrix(list, elementsPerSubArray) { //{{{
@@ -445,16 +468,147 @@
     return 0;
 } //}}}
-function ArrayUnique(arr) { //{{{
-
-	return arr.reverse().filter(function (e, i, arr) {
-		    return arr.indexOf(e, i+1) === -1;
-	}).reverse();
-} //}}}
-function ArraySort(array) { //{{{
-
-	return array.sort(function(a, b) {
-		return a - b;
-	});
-
+function ArrayUnique(arr,rows) { //{{{
+	if (arguments.length == 2){
+		if (rows == 'rows') {
+			//See Matlab unique function and https://stackoverflow.com/a/20339709/1905613
+			let equals = (a, b) => JSON.stringify(a) === JSON.stringify(b);
+			let uniques = [];
+			let indexA = [];
+			let indexC = [];
+			let itemsFound = {};;
+			for(let i = 0, l = arr.length; i < l; i++) {
+				let stringified = JSON.stringify(arr[i]);
+				if (typeof(itemsFound[stringified]) != 'undefined') {
+					indexC.push(itemsFound[stringified]);
+					continue;
+				}
+				uniques.push(arr[i]);
+				indexA.push(i);
+				itemsFound[stringified] = uniques.length-1;
+				indexC.push(itemsFound[stringified]);
+			}
+			//assert arr == uniques[indexC,:];
+			for (let i = 0; i < indexC.length; i++) {
+				if (!equals(arr[i], uniques[indexC[i]])) {
+					throw new Error('bad implementation');	
+				}
+			}
+			//assert uniques == arr[indexA, :];
+			for (let i = 0; i < indexA.length; i++) {
+				if (!equals(uniques[i], arr[indexA[i]])) {
+					throw new Error('bad implementation');	
+				}
+			}
+			let [uniquesSorted, indexInToOut, indexOutToIn] = ArraySortWithIndices(uniques);
+			//indexMapping is the index of the edge in the old array
+			indexCSorted = []; //indexC.length == arr.length
+			//assert uniquesSorted[i,:] = uniques[indexInToOut[i],:]
+			for (let i = 0; i < indexInToOut.length; i++) {
+				if (!equals(uniquesSorted[i], uniques[indexInToOut[i]])) {
+					console.log(i, uniquesSorted[indexInToOut[i]], uniques[i]);
+					throw new Error('bad implementation');	
+				}
+			}
+			//assert uniques[i,:] = uniquesSorted[indexOutToIn[i],:]
+			for (let i = 0; i < indexOutToIn.length; i++) {
+				if (!equals(uniques[i], uniquesSorted[indexOutToIn[i]])) {
+					console.log(i, uniques[indexOutToIn[i]], uniquesSorted[i]);
+					throw new Error('bad implementation');	
+				}
+			}
+			//GOAL: assert arr[i,:] == uniquesSorted[indexCSorted[i], :]
+			//GIVEN: assert arr[i,:] == uniques[indexC[i],:];
+			//GIVEN: assert uniquesSorted[i,:] = uniques[indexInToOut[i],:]
+			//GIVEN: assert uniques[i,:] = uniquesSorted[indexOutToIn[i],:]
+			//assert uniques[indexC[i],:] == uniquesSorted[indexOutToIn[indexC[i]],:]
+			//assert uniquesSorted[indexCSorted[i],:]; == uniquesSorted[indexOutToIn[indexC[i]],:];
+			for (let i = 0; i < arr.length; i++) {
+				indexCSorted[i] = indexOutToIn[indexC[i]];
+			}
+			for (let i = 0; i < indexC.length; i++) {
+				if (!equals(arr[i], uniquesSorted[indexCSorted[i]])) {
+					console.log(i, arr[i], uniquesSorted[indexCSorted[i]]);
+					throw new Error('bad implementation');	
+				}
+			}
+
+			indexASorted = []; //indexA.length == uniques.length
+			//GOAL: uniquesSorted[i, :] == arr[indexASorted[i], :]
+			//GIVEN: assert arr[i,:] == uniques[indexC[i],:];
+			//GIVEN: assert arr[indexA[i],:] == uniques[i,:];
+			//GIVEN: assert uniques[indexInToOut[i],:] == uniquesSorted[i,:]
+			//GIVEN: assert uniques[i,:] = uniquesSorted[indexOutToIn[i],:]
+			//assert uniquesSorted[i,:] == uniques[indexInToOut[i],:]
+			//assert uniques[indexInToOut[i],:] == arr[indexA[indexInToOut[i]],:];
+			//assert indexA[indexInToOut] == indexASorted
+			//indexASorted == indexA[indexMapping[i]]
+			for (let i = 0; i < indexA.length; i++) {
+				indexASorted[i] = indexA[indexInToOut[i]];
+			}
+			//assert uniques == arr[indexA, :];
+			for (let i = 0; i < indexASorted.length; i++) {
+				if (!equals(uniquesSorted[i], arr[indexASorted[i]])) {
+					throw new Error('bad implementation');	
+				}
+			}
+			console.log('Good uniques');
+			return [uniquesSorted, indexASorted, indexCSorted];
+		} else {
+			throw new Error('ArrayUnique non "rows" not supported');	
+		}
+	} else {
+		return arr.reverse().filter(function (e, i, arr) {
+				return arr.indexOf(e, i+1) === -1;
+		}).reverse();
+	}
+} //}}}
+function ArraySortWithIndices(toSort, sortingFunction) { //{{{
+	//returns the sorted and index such that toSort[index[i]] == sorted[i]
+	let toSortCopy = [];
+	for (var i = 0; i < toSort.length; i++) {
+	    toSortCopy[i] = [toSort[i], i];
+	}
+	if (typeof(sortingFunction) == 'undefined') {
+		let numeric2DFunction = function(a, b) {
+			if (a[0][0] == b[0][0]) {
+                return a[0][1] - b[0][1];
+			} else {
+			    return a[0][0] - b[0][0];
+			}
+		};
+		sortingFunction = numeric2DFunction;
+	}
+	toSortCopy.sort(sortingFunction);
+	let indicesInToOut = [];
+	let indicesOutToIn = [];
+	let sorted = [];
+	for (var j = 0; j < toSortCopy.length; j++) {
+	    indicesInToOut[j] = toSortCopy[j][1];
+	    indicesOutToIn[toSortCopy[j][1]] = j;
+	    sorted[j] = toSortCopy[j][0];
+	}
+	return [sorted, indicesInToOut, indicesOutToIn];
+} //}}}
+function ArraySort(array,dim) { //{{{
+	let numericFunction = function(a, b) {
+	    return a - b;
+	};
+	let numeric2DFunction = function(a, b) {
+	    return a[0] - b[0];
+	};
+	if (arguments.length == 2){
+		if (dim == 1) {
+			array.sort(numeric2DFunction);
+		} else if (dim == 2) {
+			for (let i = 0; i < array.length; i++) {
+				array[i].sort(numericFunction);
+			}
+		} else {
+			throw new Error('ArraySort dim > 2 not yet supported')
+		}
+		return array;
+	} else {
+		return array.sort(numericFunction);
+	}
 } //}}}
 function ArrayRange(lower, upper) { //{{{
@@ -515,7 +669,100 @@
 } //}}}
 function ArrayAnd(array1,array2) { //{{{
-
-	var array=array1;
-	for (var i=0;i<array1.length;i++)array[i]=array1[i] & array2[i];
+	var array = new Array(array1.length);
+	for (var i=0;i<array1.length;i++) {
+		array[i]=array1[i] & array2[i];
+	}
+	return array;
+} //}}}
+function ArrayOr(array1,array2) { //{{{
+	var array = new Array(array1.length);
+	for (var i=0;i<array1.length;i++) {
+		array[i]=array1[i] | array2[i];
+	}
+	return array;
+} //}}}
+function ArrayEqual(array1,array2) { //{{{
+	var array = new Array(array1.length);
+
+	if (typeof(array1[0]) == 'number') {
+		if (typeof(array2) == 'number') {
+			for(var i=0;i<array1.length;i++){
+				array[i] = array1[i] == array2;
+			}
+		} else {
+			for(var i=0;i<array1.length;i++){
+				array[i] = array1[i] == array2[i];
+			}
+		}
+	} else { //provide support for 2d arrays
+		if (typeof(array2) == 'number') {
+			for(var i=0;i<array1.length;i++){
+				array[i] = new Array(array1[i].length);
+				for(var j=0;j<array1[i].length;j++){
+					array[i][j] = array1[i][j] == array2;
+				}
+			}
+		} else {
+			for(var i=0;i<array1.length;i++){
+				array[i] = new Array(array1[i].length);
+				for(var j=0;j<array1[i].length;j++){
+					array[i][j] = array1[i][j] == array2[i][j];
+				}
+			}
+		}
+	}
+	return array;
+} //}}}
+function ArrayLessThan(array1,array2) { //{{{
+	var array = new Array(array1.length);
+
+	if (typeof(array2) == 'number') {
+		for(var i=0;i<array1.length;i++){
+			array[i] = array1[i] < array2;
+		}
+	} else {
+		for(var i=0;i<array1.length;i++){
+			array[i] = array1[i] < array2[i];
+		}
+	}
+	return array;
+} //}}}
+function ArrayGreaterThan(array1,array2) { //{{{
+	var array = new Array(array1.length);
+	if (typeof(array2) == 'number') {
+		for(var i=0;i<array1.length;i++){
+			array[i] = array1[i] > array2;
+		}
+	} else {
+		for(var i=0;i<array1.length;i++){
+			array[i] = array1[i] > array2[i];
+		}
+	}
+	return array;
+} //}}}
+function ArrayLessEqualThan(array1,array2) { //{{{
+	var array = new Array(array1.length);
+	if (typeof(array2) == 'number') {
+		for(var i=0;i<array1.length;i++){
+			array[i] = array1[i] <= array2;
+		}
+	} else {
+		for(var i=0;i<array1.length;i++){
+			array[i] = array1[i] <= array2[i];
+		}
+	}
+	return array;
+} //}}}
+function ArrayGreaterEqualThan(array1,array2) { //{{{
+	var array = new Array(array1.length);
+	if (typeof(array2) == 'number') {
+		for(var i=0;i<array1.length;i++){
+			array[i] = array1[i] >= array2;
+		}
+	} else {
+		for(var i=0;i<array1.length;i++){
+			array[i] = array1[i] >= array2[i];
+		}
+	}
 	return array;
 } //}}}
@@ -551,5 +798,5 @@
 	return arr;
 } //}}}
-function NewArrayFillIncrement(size,start,increment) { //{{{
+function NewArrayFillIncrement(start,size,increment) { //{{{
 	var array=new Array(size); 
 
@@ -559,4 +806,10 @@
 
 	return array;
+} //}}}
+function ones(size) { //{{{
+	return NewArrayFill(size,1);
+} //}}}
+function zeros(size) { //{{{
+	return NewArrayFill(size,0);
 } //}}}
 function ArrayFind(array,value) { //{{{
@@ -611,4 +864,30 @@
 	}
 	return indices;
+} //}}}
+function ArrayIndex(array1,array2,value) { //{{{
+	//Change behavior between get (if no value is provided) to set (if value to set is provided)
+	if (arguments.length == 2){
+		let data = []
+		if (typeof(array2[0]) == 'number') {
+			for (let i=0;i<array2.length;i++){
+				data.push(array1[array2[i]]);
+			}
+		} else {
+			//2d index array
+			for (let i=0;i<array2.length;i++){
+				let data2 = [];
+				for (let j=0;j<array2[i].length;j++){
+				    data2.push(array1[array2[i][j]]);
+				}
+				data.push(data2);
+			}
+		}
+		return data;
+	} else {
+		for (var i=0;i<array2.length;i++){
+			array1[array2[i]]=value;
+		}
+		return array1;
+	}
 } //}}}
 function Create2DArray(rows,cols) { //{{{
@@ -644,5 +923,5 @@
 
 	// Handle Array
-	if (obj instanceof Array) {
+	if (obj instanceof Array || arg instanceof Float64Array) {
 		copy = [];
 		for (var i = 0, len = obj.length; i < len; i++) {
